﻿using System.Windows.Media.Media3D;
using ProjectorToolkit;
using ProjectorToolkit.Controller;
using ProjectorToolkit.Elements;

namespace Pictures_on_Extended_Canvas
{
    /// <summary>
    /// Moves images around an extended virtual canvas. Images can be placed on- and off-screen.
    /// </summary>
    class Program
    {
        private const double WIDTH = 320;
        private const double HEIGHT = 240;
        public const double Z = -60;


        static void Main(string[] args)
        {
            new Program();
        }

        public Program()
        {
            // Create a new environment
            IEnvironment env = new XmlEnvironment();

            // Add a bunch of images into the world
            env.World.Add(new ImageElement(new Point3D(-200, 1400, Z), WIDTH, HEIGHT, @"images\1.jpeg"));
            env.World.Add(new ImageElement(new Point3D(100, 1400, Z), WIDTH, HEIGHT, @"images\2.jpeg"));
            env.World.Add(new ImageElement(new Point3D(0, 1600, Z), WIDTH, HEIGHT, @"images\3.jpeg"));
            env.World.Add(new ImageElement(new Point3D(-100, 1200, Z), WIDTH, HEIGHT, @"images\4.jpeg"));
            env.World.Add(new ImageElement(new Point3D(-1200, 1400, Z), WIDTH, HEIGHT, @"images\1.jpeg"));
            env.World.Add(new ImageElement(new Point3D(1100, 1400, Z), WIDTH, HEIGHT, @"images\2.jpeg"));
            env.World.Add(new ImageElement(new Point3D(10, 1600, Z), WIDTH, HEIGHT, @"images\3.jpeg"));
            env.World.Add(new ImageElement(new Point3D(-1100, 1200, Z), WIDTH, HEIGHT, @"images\4.jpeg"));
            env.World.Add(new ImageElement(new Point3D(1200, 1400, Z), WIDTH, HEIGHT, @"images\1.jpeg"));
            env.World.Add(new ImageElement(new Point3D(2100, 1400, Z), WIDTH, HEIGHT, @"images\2.jpeg"));
            env.World.Add(new ImageElement(new Point3D(20, 1600, Z), WIDTH, HEIGHT, @"images\3.jpeg"));
            env.World.Add(new ImageElement(new Point3D(1100, 1200, Z), WIDTH, HEIGHT, @"images\4.jpeg"));

            // Set controller and create handler to control the pictures
            WiiRemoteElement wiiRemote = new WiiRemoteElement();
            new MoveHandler(wiiRemote.ButtonA);
            new DirectManipulationHandler(wiiRemote.Button1);
            new OnLeashHandler(wiiRemote.Button2);
            env.Tracker.BindToTrackedObject(wiiRemote, "MarkerA");
            env.CursorDB.Register(wiiRemote);
        }
    }
}
