﻿using ProjectorToolkit.Elements;

namespace ProjectorToolkit.Controller
{
    public enum ButtonState { Pressed, Released }

    public class Button
    {
        public AbstractElement parent;
        private ButtonState state = ButtonState.Released;

        public delegate void ButtonHandler(AbstractElement sender, ButtonState state);
        public event ButtonHandler Changed = delegate { };

        public Button(AbstractElement parent)
        {
            this.parent = parent;
        }

        public ButtonState State
        {
            get { return state; }
            set { state = value; Changed(parent, state); }
        }
    }
}
