﻿using System;
using System.Windows.Media.Media3D;
using ProjectorToolkit.Utilities;

namespace ProjectorToolkit.Filter
{
    /// <summary>
    /// Updates only if the new target to last update distance
    /// is bigger than the used threshold.
    /// </summary>
    public class ConstantGridFilter : GridFilter
    {
        private double thresholdDistance;

        public ConstantGridFilter(double thresholdDistance)
        {
            this.thresholdDistance = thresholdDistance;
        }

        protected override bool ShouldUpdate(Point3D position, Point3D lastHit, Point3D newHit)
        {
            double distance = Math.Abs(lastHit.DistanceTo(newHit));
            return distance >= thresholdDistance;
        }
    }
}
