﻿using System.Windows.Media.Media3D;
using ProjectorToolkit.Elements;
using ProjectorToolkit.World;

namespace ProjectorToolkit.Filter
{
    /// <summary>
    /// Jumps from one element to another, but does not move in between.
    /// </summary>
    public class ElementJumping : AbstractFilter
    {
        private AbstractElement lastElement;

        public override void Filter(Point3D position, Vector3D direction, Vector3D up)
        {
            AbstractElement target = ServerWorld.Instance.PointingTarget(position, direction);
            if (lastElement != target)
            {
                UpdateFilter(position, direction, up);
                lastElement = target;
            }
        }
    }
}
