﻿using System.Windows;
using System.Windows.Media.Media3D;

namespace ProjectorToolkit.Utilities
{
    /// <summary>
    /// A 2D polygon in a plane.
    /// </summary>
    public class Polygon3D
    {
        private Plane plane;
        private Polygon polygon;

        public Polygon3D(Point3D point, Vector3D normal, Polygon polygon)
        {
            this.plane = new Plane(point, normal);
            this.polygon = polygon;
        }

        public Point3D? Intersection(Point3D origin, Vector3D direction)
        {
            Point3D? hit = plane.Intersection(origin, direction);
            if (hit != null)
            {
                Point hitIn2D = plane.RelativeCoordinateFor((Point3D)hit);

                if (polygon.Contains(hitIn2D))
                    return hit;
            }
            return null;
        }
    }
}
