﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using ProjectorToolkit.Utilities;

namespace ProjectorToolkitTests.Utilities
{
    [TestClass]
    public class AngleTest
    {
        [TestMethod]
        public void AngleFromZeroDegreeShouldBeZeroRadian()
        {
            Assert.AreEqual(0, Angle.FromDegrees(0).InRadians);
        }

        [TestMethod]
        public void AngleFromZeroRadianShouldBeZeroDegree()
        {
            Assert.AreEqual(0, Angle.FromRadians(0).InDegrees);
        }

        [TestMethod]
        public void ShouldRecognizeZeroAngle()
        {
            Assert.IsTrue(Angle.FromDegrees(0.1).IsNotZero);
            Assert.IsTrue(Angle.FromDegrees(0).IsZero);
        }

        [TestMethod]
        public void ShouldNormalizeAngle()
        {
            Assert.AreEqual(0, Angle.FromDegrees(360).InDegrees);
            Assert.AreEqual(0, Angle.FromDegrees(-360).InDegrees);
            Assert.AreEqual(314.5, Angle.FromDegrees(-45.5).InDegrees);
            Assert.AreEqual(85.5, Angle.FromDegrees(445.5).InDegrees);
        }

    }
}
